#include <stdio.h>
#include <ctype.h>

#define MAXN 20000

int w[MAXN];
int h[MAXN];

int maxlen[MAXN];

void myqsort( int begin, int end ){
  int b = begin - 1, e = end + 1, p = w[(begin + end) / 2], aux;
  
  while( w[++b] < p );
  while( w[--e] > p );
  
  while( b < e ){
    aux = w[b];
    w[b] = w[e];
    w[e] = aux;
    
    aux = h[b];
    h[b] = h[e];
    h[e] = aux;

    while( w[++b] < p );
    while( w[--e] > p );
  }
  
  if( begin < e )
    myqsort(begin, e);
  if( e + 1 < end )
    myqsort(e + 1, end);
}

static inline int fgetint(){
  int n = 0, ch;
  
  while( !isdigit(ch = fgetc(stdin)) );
  do
    n = n * 10 + ch - '0';
  while( isdigit(ch = fgetc(stdin)) );
  
  return n;
}

int main(){
  int n, i, j, out;
  
  n = fgetint();
  for( i = 0 ; i < n ; i++ ){
    w[i] = fgetint();
    h[i] = fgetint();
  }
  
  myqsort(0, n - 1);// sort by width
  
  // do largest strictly decreasing subsequence on heights
  // slow method, maybe passes because of 1/2 constant
  maxlen[0] = out = 1;
  for( i = 0 ; i < n ; i++ ){
    maxlen[i] = 0;

    for( j = 0 ; j < i ; j++ )
      if( (w[j] != w[i] && h[j] >= h[i]) || h[j] > h[i] )
        maxlen[i] = maxlen[j] > maxlen[i] ? maxlen[j] : maxlen[i];

    maxlen[i]++;// add i
    
    //printf("@(%d, %d) -> maxlen = %d\n", w[i], h[i], maxlen[i]);

    out = maxlen[i] > out ? maxlen[i] : out;
  }
  
  printf("%d\n", out);
  
  return 0;
}