#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;

struct X
{
    int x;
    int y;

    bool operator< (const X& c) const
    {
        if (x == c.x)
            return y > c.y;
        return x < c.x;
    }

    bool operator== (const X& c) const
    {
        return x == c.x && y == c.y;
    }
};

int main()
{
    int n;
    cin >> n;
    vector<X> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    n = a.size();
    stack<pair<int, int>> s;
    vector<int> res(n);
    for (int i = 0; i < n; ++i)
    {
        while (!s.empty() && s.top().first <= a[i].y)
        {
            s.pop();
        }
        if (s.empty())
            res[i] = 0;
        else
            res[i] = s.top().second + 1;
        s.push({ a[i].y, i });
    }
    vector<int> dp(n + 1);
    dp[0] = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (res[i - 1] == 0)
            dp[i] = 1;
        else
            dp[i] = max(dp[res[i - 1]] + 1, dp[res[res[i - 1] - 1]] + 1);
    }
    int maxx = 0;
    for (int i = 1; i <= n; ++i)
        maxx = max(maxx, dp[i]);
    cout << maxx << '\n';
    return 0;
}
