#include <vector>
#include <iostream>
#include <algorithm>

int main()
{
	int n;
	std::cin >> n;
	std::vector<std::pair<int, int>> rectangles(n);
	for (int i = 0; i < n; i++)
		std::cin >> rectangles[i].first >> rectangles[i].second;

	std::sort(rectangles.begin(), rectangles.end(), 
		[](std::pair<int, int> a, std::pair<int, int> b) { 
			if (a.first == b.first)
				return a.second > b.second;
			return a.first < b.first; 
		});

	int maxChain = 1, current = 1, last = -1;
	for (auto rec : rectangles) {
		if (rec.second < last) {
			current++;
		}
		else current = 1;

		maxChain = std::max(maxChain, current);
			
		last = rec.second;
	}

	std::cout << maxChain;

	return 0;
}