#include <iostream>
#include <algorithm>
using namespace std;
const int maxn = 3e4+10;

int tree[4*maxn], jump[maxn], res[maxn];
pair < int, int > rect[maxn];
int n;

void update(int l, int r, int node, int query_ix, int query_val) {

    if (l == r) {

        tree[node] = query_val;
        return;

    }

    int mid = (l+r)/2;

    if (query_ix <= mid) update(l, mid, 2*node, query_ix, query_val);
    else update(mid+1, r, 2*node+1, query_ix, query_val);

    tree[node] = max(tree[2*node], tree[2*node+1]);

}

int query(int l, int r, int node, int query_ix) {

    if (r <= query_ix) return tree[node];
    int mid = (l+r)/2;

    int res = query(l, mid, 2*node, query_ix);
    if (mid+1 <= query_ix) res = max(query(mid+1, r, 2*node+1, query_ix), res);
    return res;

}

void solve() {

    sort(rect+1, rect+1+n, greater < pair < int, int > > ());

    int last = 0;
    for (int i = n ; i >= 1 ; --i) {

        if (rect[i].first != rect[last].first) last = i;
        jump[i] = last;

    }

    for (int i = 1 ; i <= n ; ++i) {

        for (int j = i ; j <= jump[i] ; ++j) res[j] = query(0, n, 1, rect[i].second-1)+1;
        for (int j = i ; j <= jump[i] ; ++j) update(0, n, 1, rect[i].second, res[i]);
        i = jump[i];

    }

    // cout << "res: \n";

    int ans = 0;
    for (int i = 1 ; i <= n ; ++i) {
        // cout << res[i] << ' ';
        ans = max(ans, res[i]);
    }

    // cout << '\n';

    cout << ans << '\n';

}

void read() {

    cin >> n;
    for (int i = 1 ; i <= n ; ++i)
        cin >> rect[i].first >> rect[i].second;

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

int main () {

    fast_io();
    read();
    solve();

}