/*
POTOK ZA ILIQN
*/
#include <bits/stdc++.h>

using namespace std;
const int maxn = 5e4 + 10, inf = 1e9;

struct edge
{
    int v, u, cap, flow;

    edge(int _v, int _u, int _cap)
    {
        v = _v;
        u = _u;
        cap = _cap;
        flow = 0;
    }
};

struct Dinic
{
    vector < vector < int > > g;
    vector < edge > edges;
    vector < int > lvl, ptr;
    int n, m, s, t;

    Dinic(int _n, int _s, int _t)
    {
        n = _n;
        s = _s;
        t = _t;
        m = 0;
        lvl.resize(n + 1);
        ptr.resize(n + 1);
        g.resize(n + 1);
    }

    void add_edge(int v, int u, int cap)
    {
        edges.emplace_back(v, u, cap);
        edges.emplace_back(u, v, 0);
        g[v].push_back(m);
        g[u].push_back(m + 1);
        m += 2;
    }

    bool bfs()
    {
        fill(ptr.begin(), ptr.end(), 0);
        fill(lvl.begin(), lvl.end(), 0);
        queue < int > q;
        lvl[s] = 1;
        q.push(s);
        while(!q.empty())
        {
            int cur = q.front();
            ///cout << cur << endl;
            q.pop();
            for (int i = 0; i < g[cur].size(); i ++)
            {
                int idx = g[cur][i];
                ///cout << edges[idx].u << " -- " << edges[idx].cap << " " << lvl[edges[idx].u] << endl;
                if (edges[idx].cap - edges[idx].flow > 0 && lvl[edges[idx].u] == 0)
                {
                    lvl[edges[idx].u] = lvl[cur] + 1;
                    q.push(edges[idx].u);
                }
            }
        }

        return lvl[n] != 0;
    }

    int dfs(int v, int pushed = inf)
    {
        if (v == t)
            return pushed;
        for (int i = ptr[v]; i < g[v].size(); ptr[v] = ++ i)
        {
            int idx = g[v][i];
            int u = edges[idx].u, to_go = edges[idx].cap - edges[idx].flow;
            if (to_go == 0 || lvl[u] != lvl[v] + 1)
                continue;
            int tr = dfs(u, min(to_go, pushed));
            if (tr == 0)
                continue;
            edges[idx].flow += tr;
            edges[idx ^ 1].flow -= tr;
            return tr;
        }
        return 0;
    }

    int flow()
    {
        int f = 0;
        while(bfs())
        {
            while(int pushed = dfs(s))
                f += pushed;
        }
        return f;
    }
};

int n, m;
void solve()
{
    cin >> n >> m;
    Dinic dnc(n, 1, n);
    for (int i = 1; i <= m; i ++)
    {
        int v, u, c;
        cin >> v >> u >> c;
        dnc.add_edge(v, u, c);
    }

    int flow = dnc.flow();
    cout << flow << endl;
}
int main()
{
    solve();
    return 0;
}
/**
5 5
1 2 1
1 3 2
1 4 1
4 5 1
3 5 2

*/
